# to be source by the various geth-utils scripts
GVERSION=0.9

_defineChain () {
   if   [ \! -z "$CMDLINECHAIN" -a -z "$FIXEDCHAIN" ]; then
      CHAIN=$CMDLINECHAIN
   elif [ \! -z "$ETHERCHAIN" -a -z "$FIXEDCHAIN" ]; then
      CHAIN=$ETHERCHAIN
   elif [ \! -z "$CMDLINECHAIN" -a \! -z "$FIXEDCHAIN" ]; then
      if [ "$CMDLINECHAIN" = "$FIXEDCHAIN" ]; then
          CHAIN=$FIXEDCHAIN
      else
          echo "ERROR: Chain ID from command line ($CMDLINECHAIN) differs from FIXEDCHAIN ($FIXEDCHAIN)."
          exit 17
      fi
   elif [ \! -z "$ETHERCHAIN" -a \! -z "$FIXEDCHAIN" ]; then
      if [ "$ETHERCHAIN" = "$FIXEDCHAIN" ]; then
          CHAIN=$FIXEDCHAIN
      else
          echo "ERROR: Chain ID from ETHERCHAIN ($ETHERCHAIN) differs from FIXEDCHAIN ($FIXEDCHAIN)."
          exit 17
      fi
   elif [ -z "$ETHERCHAIN" -a -z "$CMDLINECHAIN" -a \! -z "$FIXEDCHAIN" ]; then
          CHAIN=$FIXEDCHAIN
   else
          echo "ERROR: No chain defined. Run wit -c CHAIN or with variable ETHERCHAIN defined."
          exit 17
   fi
   case $CHAIN in
     loc|ropsten|fh|ether)
         ;;
     *)
         echo "ERROR: Unknown chain: $CHAIN."
         exit 17
         ;;
   esac
}

_set_git_version () {
    if [ "$1" = latest ]; then
       VERSION=master
    elif [ "$1" = master ]; then
       VERSION=master
    elif [ "$1" = release ]; then
       VERSION=tags/"`git tag --sort=-creatordate | head -1`"
    else
       VERSION=tags/$1
    fi
}