// console.log("gethrc.js preliminaries. Use d() for debug, p() for print");
// console.log("gethrc.js preliminaries...");

// vvvvvv edit vvvvvvvv
//----------------------------                   //
var gasPriceToPay = '5'                          // gas price wie want to pay in transactions; in gwei
// ^^^^^^ edit ^^^^^^^^
// console.log("setting var gasPriceToPay = " + gasPriceToPay + " gwei");

//--Initialization-------------------------------//
if ( typeof eth.accounts[0] != 'undefined' ) { eth.defaultAccount = eth.accounts[0] };
//-----------------------------------------------//

//----------------------------                   //
function p(line) {                               // print line on console.log
   console.log(line);
}

//----------------------------                   //
function gasDefined() {                          // return true if gasPriceToPay is defined, else false
  return ( typeof gasPriceToPay != 'undefined' );
}

//----------------------------                   //
function recommendGas() {                        // recommend a gas price, print to console.log
  var maxblock = eth.blockNumber
  var maxgas = 0.0;
  var mingas = 0.0;
  var sumgas = 0.0;
  // console.log("Blocklist of the last " + nbrblocks + " blocks starting from the latest block " + maxblock )
  // console.log("Block Number " + bn + " hash " + eth.getBlock(bn).hash + ":")
    for ( i = 0; i < eth.getBlock(maxblock).transactions.length ; i++ ) {
        // listTx(eth.getBlock(maxblock).transactions[i]);
        var x = eth.getTransaction(eth.getBlock(maxblock).transactions[i]).gasPrice * 1
        // var gp = web3.fromWei(x,'gwei') * 1
        if ( x > maxgas ) { maxgas = x };
        if ( x < mingas || mingas == 0 ) { mingas = x };
        sumgas = sumgas + x
        // console.log("Tx gas: " + x + " = " + web3.fromWei(x,'gwei') + " gwei, sum is " + sumgas);
    }
   console.log("Gas recommendation from block " + maxblock + " (" + eth.getBlock(maxblock).transactions.length + " txes)" + 
                  " from " + 
                  ( new Date(eth.getBlock(maxblock).timestamp * 1000).toUTCString() ) + 
                  ": min: " + web3.fromWei(mingas,'gwei') + " gwei, max: " + web3.fromWei(maxgas,'gwei') + " gwei, med: " + 
                  web3.fromWei( sumgas/eth.getBlock(maxblock).transactions.length ,'gwei')
              )
}

//----------------------------                   //
function payGas(_gp) {                           // define a new gasPriceToPay; in gwei
    if ( typeof _gp == 'undefined' || _gp == null || _gp == 0 ) {
        if ( gasDefined() ) {
               console.log("Leaving gas price we want to pay: " + gasPriceToPay + " gwei.")
        } else {
               console.log("ATTENTION: Current gas price we want to pay NOT DEFINED!")
        }
    } else {
       console.log("Setting gas price we want to pay to " + _gp + " gwei.")
       gasPriceToPay = _gp
    }
}

//----------------------------                   //
function readStorage(theAddress, upperlimit) {   // read storage of contract at theAdresse up to upperlimit words
   for (index = 0; index < upperlimit; index++){
         var storage = eth.getStorageAt(theAddress,index);
         var ts=web3.toAscii(storage).replace(/[^0-9a-zA-Z\xC0-\xFF \-]/g, '');
         if ( storage != 0 ) {
                 console.log("[" + index + "] " + storage + " " +
                        web3.toDecimal(storage) + " \"" +
                        ts +"\""
                 );
         }
   }
}

//----------------------------                   //
function dt (dateInt) {                          // convert date in readable form from an date int
   return "Date @" + dateInt + " is: " + ( new Date(dateInt * 1000).toUTCString() )
}

//----------------------------                   //
function listTx (txnbr) {                        // list the txnbr
      to = eth.getTransaction(txnbr).to;
      from = eth.getTransaction(txnbr).from;
      if ( to == null ) {
           cnt = eth.getTransactionReceipt(txnbr).contractAddress;
           console.log("   tx: " + txnbr + 
                       " from: " + eth.getTransaction(txnbr).from +
                       " creating: " + cnt +
                       " gasPrice: " + web3.fromWei(eth.getTransaction(txnbr).gasPrice,'gwei') + " gwei"
                     );
      } else {
           console.log("   tx: " + txnbr + 
                       " from: " + eth.getTransaction(txnbr).from +
                       " to: " + to +
                       " gasPrice: " + web3.fromWei(eth.getTransaction(txnbr).gasPrice,'gwei') + " gwei"
                    );
      }
}

/*
NOTAfunction listTx (txnbr) {
      to = eth.getTransaction(txnbr).to;
      from = eth.getTransaction(txnbr).from;
      if ( to == null ) {
         cnt = cnt = eth.getTransactionReceipt(txnbr).contractAddress;
           console.log("   tx: " + eth.getBlock(bn).transactions[i] + 
                       " from: " + eth.getTransaction(eth.getBlock(bn).transactions[i]).from +
                       " creating: " + cnt +
                       " gasPrice: " + web3.fromWei(eth.getTransaction(eth.getBlock(bn).transactions[i]).gasPrice,'gwei') + " gwei"
                     );
      } else {
           console.log("   tx: " + eth.getBlock(bn).transactions[i] + 
                       " from: " + eth.getTransaction(eth.getBlock(bn).transactions[i]).from +
                       " to: " + to +
                       " gasPrice: " + web3.fromWei(eth.getTransaction(eth.getBlock(bn).transactions[i]).gasPrice,'gwei') + " gwei"
                    );
      }
}
*/

//----------------------------                   //
function listblocks (nbrblocks) {                // the same as listBlocks(...)
    listBlocks(nbrblocks)
}

//----------------------------                   //
function listBlocks (nbrblocks) {                // list nbrblocks blocks to console
  var maxblock = eth.blockNumber
  console.log("Blocklist of the last " + nbrblocks + " blocks starting from the latest block " + maxblock )
  for ( bn=maxblock; (maxblock-bn) < nbrblocks && bn >= 0; bn-- ) {
    console.log("Block Number " + bn + " hash " + eth.getBlock(bn).hash + ":")
    // for ( i = 0; typeof eth.getBlock(bn).transactions[i] !== 'undefined' ; i++ ) {
    for ( i = 0; i < eth.getBlock(bn).transactions.length ; i++ ) {
        listTx(eth.getBlock(bn).transactions[i]);
    }
  }
}

//----------------------------                   //
function grepBlocks (_addr,nbrblocks) {          // grep in the last nbrblocks blocks for the address _addr
  var maxblock = eth.blockNumber
  console.log("Blocksearch of the last " + nbrblocks + " blocks starting from the latest block " + maxblock + " for address " + _addr)
  for ( bn=maxblock; (maxblock-bn) < nbrblocks && bn >= 0; bn-- ) {
    for ( i = 0; typeof eth.getBlock(bn).transactions[i] !== 'undefined' ; i++ ) {
           from = eth.getTransaction(eth.getBlock(bn).transactions[i]).from;
           to = eth.getTransaction(eth.getBlock(bn).transactions[i]).to;
           cnt = eth.getTransactionReceipt(eth.getBlock(bn).transactions[i]).contractAddress;
           if ( to == _addr || from == _addr ) {
                   console.log("Block Number " + bn + " (cnf: " + ( maxblock - bn ) + ") hash " + eth.getBlock(bn).hash + ":")
                   listTx(eth.getBlock(bn).transactions[i]);
           } else if (cnt == _addr) { 
                   console.log("Block Number " + bn + " (cnf: " + ( maxblock - bn ) + ") hash " + eth.getBlock(bn).hash + ":")
                   listTx(eth.getBlock(bn).transactions[i]);
           }
    }
  }
}


//----------------------------                   //
function balances () {                           // Balances of all your accounts from eth.getBalance(eth.accounts[*])
   console.log("Balances of all your accounts from eth.getBalance(eth.accounts[*])")
   for ( i = 0; typeof eth.accounts[i] !== 'undefined' ; i++ ) {
      p ( "accounts[" + i + "], address: " +
        eth.accounts[i] + ", balance: " +
        web3.fromWei(eth.getBalance(eth.accounts[i]),"ether") +
        " ether"
      );
   }
}

//----------------------------                   //
function wallets () {                            // Balances of all your wallets and accounts from personal.listWallets
   console.log("Balances of all your wallets and accounts from personal.listWallets:");
   for ( i = 0; i < personal.listWallets.length; i++ ) {
       for ( j = 0; j < personal.listWallets[i].accounts.length; j++ ) {
/*                 console.log( "wallet " + i + " account " + j + 
                              " has address " + personal.listWallets[i].accounts[j].address + 
                              " status " + personal.listWallets[i].status ); */
             for ( k = 0; k < eth.accounts.length; k++ ) 
                if ( eth.accounts[k] == personal.listWallets[i].accounts[j].address ) {
                 if ( eth.accounts[k] == eth.defaultAccount ) {
                    defstring="DEFAULT"
                 } else {
                    defstring="       "
                 }
                 console.log( "wallet " + i + " account " + j + " is eth.account[" + k + "], " + 
                              "address: " + personal.listWallets[i].accounts[j].address + ", " +
                              defstring + " " +
                              "status: " + personal.listWallets[i].status + ", " +
                              "balance: " + web3.fromWei(eth.getBalance(eth.accounts[k]),"ether") + " ether"
                             );
/*                      console.log( "     this is eth.accounts[" + k + "], address: " + eth.accounts[k] + 
                                        ", balance: " + web3.fromWei(eth.getBalance(eth.accounts[i]),"ether") + " ether"
                                 );*/
             }
       }
   }
}

//----------------------------                   //
function units() {                               // help text for ethereum units
  console.log("wei                  1    == 1                          wei");
  console.log("Kwei (babbage)       1e3  == 1 000                      wei");
  console.log("Mwei (lovelace)      1e6  == 1 000 000                  wei");
  console.log("Gwei (shannon)       1e9  == 1 000 000 000              wei");
  console.log("microether (szabo)   1e12 == 1 000 000 000 000          wei");
  console.log("milliether (finney)  1e15 == 1 000 000 000 000 000      wei");
  console.log("ether                1e18 == 1 000 000 000 000 000 000  wei");
}

//----------------------------                   //
function unlock(nbr) {                           // unlock account nbr
    p("personal.unlockAccount(eth.accounts[nbr]);" );
       personal.unlockAccount(eth.accounts[nbr]);
}

//----------------------------                   //
function lock(nbr) {                             // lock account nbr
    p("personal.lockAccount(eth.accounts[nbr]);" );
       personal.lockAccount(eth.accounts[nbr]);
}


//----------------------------                   //
function unlockaccountpw(nbr,pw) {               // unlock account with password (unsafe)
   p("personal.Account(eth.accounts[" + nbr + "],SECRET)");
   personal.unlockAccount(eth.accounts[nbr],pw);
}

//----------------------------                   //
function unlockall() {                           // unlock all accounts
    if ( typeof _unlockall == 'function' ) {
       _unlockall();
    } else {
       for (i=0;i<eth.accounts.length;i++) {
          p("personal.unlockAccount(eth.accounts[" + i + "],\"\")");
             personal.unlockAccount(eth.accounts[i],"");
       }
    }
}

//----------------------------                   //
function lockall() {                             // lock all accounts
       for (i=0;i<eth.accounts.length;i++) {
          p("personal.lockAccount(eth.accounts[" + i + "],\"\")");
             personal.lockAccount(eth.accounts[i],"");
       }
}

//----------------------------                   //
function lock(nbr) {                             // lock account nbr
    p("personal.lockAccount(eth.accounts[nbr]);" );
       personal.lockAccount(eth.accounts[nbr]);
}

//----------------------------                   //
function pai (f, t, amount,unit) {               // internal: pay amount from account f to account t; call like pai(0,1,500,"milliether")
  p("eth.sendTransaction({from:eth.accounts[f], to:eth.accounts[t], value: web3.toWei(amount, unit), gasPrice: web3.toWei(gasPriceToPay,'gwei')});");
     ts = eth.sendTransaction({from:eth.accounts[f], to:eth.accounts[t], value: web3.toWei(amount, unit), gasPrice: web3.toWei(gasPriceToPay,'gwei')});
     p("Paid. Transaction was: " + ts );
}

//----------------------------                   //
function pay (f, toaddr, amount,unit) {          // pay amount from account f to address toaddr; call like pay(0,"0x123..89",500,"milliether")
  p("eth.sendTransaction({from:eth.accounts[f], to:toaddr, value: web3.toWei(amount, unit), gasPrice: web3.toWei(gasPriceToPay,'gwei')});");
     ts = eth.sendTransaction({from:eth.accounts[f], to:toaddr, value: web3.toWei(amount, unit), gasPrice: web3.toWei(gasPriceToPay,'gwei')});
     p("Paid. Transaction was: " + ts );
}

//----------------------------                   //
function newa() {                                // create a new account
   console.log("Creating new eth.account number " + eth.accounts.length + " ... <ctrl-c> to stop");
   p("personal.newAccount();")
      personal.newAccount();
}

function defAccount(i) {                         // Set default account to account[i]
   if ( typeof eth.accounts[i] != 'undefined' ) { 
       eth.defaultAccount = eth.accounts[i];
       p("Set eth.defaultAccount to eth.accounts[" + i + "]");
   } else {
       p("eth.accounts[" + i + "] does not exist, not changing et.defaultAccount");
   }
}
